#ifndef CYGONCE_HAL_PLATFORM_INC
#define CYGONCE_HAL_PLATFORM_INC
##=============================================================================
##
##	platform.inc
##
##	Hitachi SE7206 board assembler header file
##
##=============================================================================
#####ECOSGPLCOPYRIGHTBEGIN####
## -------------------------------------------
## This file is part of eCos, the Embedded Configurable Operating System.
## Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
##
## eCos is free software; you can redistribute it and/or modify it under
## the terms of the GNU General Public License as published by the Free
## Software Foundation; either version 2 or (at your option) any later version.
##
## eCos is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without even the implied warranty of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
## for more details.
##
## You should have received a copy of the GNU General Public License along
## with eCos; if not, write to the Free Software Foundation, Inc.,
## 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
##
## As a special exception, if other files instantiate templates or use macros
## or inline functions from this file, or you compile this file and link it
## with other works to produce a work based on this file, this file does not
## by itself cause the resulting work to be covered by the GNU General Public
## License. However the source code for this file must still be made available
## in accordance with section (3) of the GNU General Public License.
##
## This exception does not invalidate any other reasons why a work based on
## this file might be covered by the GNU General Public License.
##
## Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
## at http://sources.redhat.com/ecos/ecos-license/
## -------------------------------------------
#####ECOSGPLCOPYRIGHTEND####
##=============================================================================
#######DESCRIPTIONBEGIN####
##
## Author(s): 	ysato
## Contributors:ysato
## Date:	2004-12-15
## Purpose:	Hitachi SE7206 platform startup
## Description:	This file contains various definitions and macros that are
##              useful for writing assembly code for the Hitachi SE77x9
##              board.
## Usage:
##		#include <cyg/hal/platform.inc>
##		...
##		
##
######DESCRIPTIONEND####
##
##=============================================================================

#include <pkgconf/hal.h>

#include <cyg/hal/sh_offsets.inc>
#include <cyg/hal/sh_regs.h>
	
#------------------------------------------------------------------------------
# Hardware initialization.

	.macro	hal_hardware_init
#ifndef CYG_HAL_STARTUP_RAM
	// Set up the Clock Generator (PLL)
#if 0
	mova	 CPG_settings_table,r0
	mov	 r0,r3
1:	mov.l	 @r3+,r0		// Address (or zero)
	cmp/eq	 #0,r0
	bt	 2f
	mov.l	 @r3+,r1		// data
	mov.w	 r1,@r0
	bra	 1b
	nop
	mov.l	$mclkcr,r0		// MCLKCR setting
	mov	#0x40,r1
	mov.b	r1,@r0
#endif
	// Set up the Pin Function Controler
2:
	mova	PFC_settings_table,r0
	mov	r0,r3
3:	mov.l	@r3+,r0		       // Address (or zero)
	cmp/eq	#0,r0
	bt	4f
	mov.l	@r3+,r1		       // data
	mov.l	r1,@r0
	bra	3b
	nop

	// Set up the Bus Controler
4:
	mova	BSC_settings_table,r0
	mov	r0,r3
5:	mov.l	@r3+,r0		       // Address (or zero)
	cmp/eq	#0,r0
	bt	6f
	mov.l	@r3+,r1		       // data
	mov.l	r1,@r0
	bra	5b
	nop

	.align	4
$mclkcr:
	.long	CYGARC_REG_MCLKCR

CPG_settings_table:
	.long	CYGARC_REG_WTCSR_W,0xA500
	.long	CYGARC_REG_WTCNT_W,0x5A00
	.long	CYGARC_REG_WTCSR_W,0xA51E
	.long	CYGARC_REG_FREQCR, 0x120c	/* input:33.3333MHz I:B:P=6:2:1=200MHz:66MHz:33MHz */
	.long	0

PFC_settings_table:
	.long	CYGARC_REG_PACRH3, 0x0022
	.long	CYGARC_REG_PACRH2, 0x1111
	.long	CYGARC_REG_PACRH1, 0x1115
	.long	CYGARC_REG_PACRL4, 0x1111
	.long	CYGARC_REG_PACRL3, 0x1125
	.long	CYGARC_REG_PACRL2, 0x2255
	.long	CYGARC_REG_PACRL1, 0x5500
	.long	CYGARC_REG_PBCR3,  0x0022
	.long	CYGARC_REG_PBCR2,  0x2244
	.long	CYGARC_REG_PBCR1,  0x1111
	.long	CYGARC_REG_PCCRL1, 0x1111
	.long	CYGARC_REG_PDCRH4, 0x1111
	.long	CYGARC_REG_PDCRH3, 0x1111
	.long	CYGARC_REG_PDCRH2, 0x1111
	.long	CYGARC_REG_PDCRH1, 0x1111
	.long	CYGARC_REG_PDCRL4, 0x1111
	.long	CYGARC_REG_PDCRL3, 0x1111
	.long	CYGARC_REG_PECRH1, 0x0005
	.long	CYGARC_REG_PECRL4, 0x3223
	.long	CYGARC_REG_PECRL3, 0x3030
	.long	CYGARC_REG_PECRL2, 0x3550
	.long	CYGARC_REG_IFCR,   0x0003
	.long	0

BSC_settings_table:
	# Settings from Hitachi docs for SE7206
	.long	CYGARC_REG_CMNCR,  0x00001010
	.long	CYGARC_REG_CS0BCR, 0x10000600
	.long	CYGARC_REG_CS2BCR, 0x10000600
	.long	CYGARC_REG_CS4BCR, 0x10000400
	.long	CYGARC_REG_CS5BCR, 0x10000400
	.long	CYGARC_REG_CS3BCR, 0x10004600
	.long	CYGARC_REG_CS0WCR, 0x00000380;	/* wait:4cycle				*/
	.long	CYGARC_REG_CS2WCR, 0x00000380;
	.long	CYGARC_REG_CS4WCR, 0x00000380;
	.long	CYGARC_REG_CS5WCR, 0x00000380;
	.long	CYGARC_REG_CS3WCR, 0x00004892;	/* pre->actv:1cycle, actv->read/write:2cycle, write->pre:1cycle, ref->actv:4cycle	*/
	.long	CYGARC_REG_SDCR,   0x00000811;
	.long	CYGARC_REG_RTCNT,  0xa55a0083;
	.long	CYGARC_REG_RTCOR,  0xa55a0083;
	.long	CYGARC_REG_RTCSR,  0xa55a0008;	/* reflesh count=B/4	*/
	.long	0

6:
	mov.l	$delay_count,r0
	dt	r0
	bf	6b

	mov.l	$SDMR,r1		// Turns on SDRAM controller
	mov.l	$SDMR_val,r2
	mov.b	r2,@r1
	bra	9f
	nop

	.align	4

$delay_count:
	.long	2000
$SDMR:	.long	0xffffe088
$SDMR_val:
	.long	0

9:
	mov.l	2f,r0
	mov	#0,r1
	mov.w	r1,@r0
1:
	bra	1b
	nop
2:
	.long	0x31400000
#endif // !CYG_HAL_STARTUP_RAM
	.endm

#------------------------------------------------------------------------------
# Monitor initialization.

#ifndef CYGPKG_HAL_SH_MON_DEFINED

#if	!defined(CYG_HAL_STARTUP_RAM) ||		\
	(	defined(CYG_HAL_STARTUP_RAM) &&		\
		!defined(CYGSEM_HAL_USE_ROM_MONITOR))

	# If we are not starting up from RAM, or we are starting in
	# RAM and NOT using a ROM monitor, initialize the VSR table.

	.macro	hal_mon_init
	mov.l	$hal_vsr_table,r3
	# Write exception vectors
	mov.l	$cyg_hal_default_exception_vsr,r4
	mov	#CYGNUM_HAL_VSR_EXCEPTION_COUNT,r5
1:	mov.l	r4,@r3
	add	#4,r3
	dt	r5
	bf	1b
	# Write interrupt vector
	mov.l	$cyg_hal_default_interrupt_vsr,r4
	mov.l	$hal_vsr_table,r3
	add	#CYGNUM_HAL_VECTOR_INTERRUPT*4,r3
	mov.l	r4,@r3
	bra	2f
	 nop
	.align	2

	SYM_PTR_REF(cyg_hal_default_exception_vsr)
	SYM_PTR_REF(cyg_hal_default_interrupt_vsr)
	SYM_PTR_REF(hal_vsr_table)
2:
	.endm

#elif defined(CYG_HAL_STARTUP_RAM) && defined(CYGSEM_HAL_USE_ROM_MONITOR)

	# Initialize the VSR table entries
	# We only take control of the interrupt vector,
	# the rest are left to the ROM for now...

	.macro	hal_mon_init
	# Write interrupt vector
	mov.l	$hal_vsr_table,r3
	mov.l	$cyg_hal_default_interrupt_vsr,r4
	add	#CYGNUM_HAL_VECTOR_INTERRUPT*4,r3
	mov.l	r4,@r3
	bra	2f
	 nop
	.align	2

	SYM_PTR_REF(cyg_hal_default_interrupt_vsr)
	SYM_PTR_REF(hal_vsr_table)
2:
	.endm

#else

	.macro	hal_mon_init
	.endm

#endif


#define CYGPKG_HAL_SH_MON_DEFINED

#endif // CYGPKG_HAL_SH_MON_DEFINED

#endif // CYGONCE_HAL_PLATFORM_INC
