#ifndef CYGONCE_HAL_MOD_7206_H
#define CYGONCE_HAL_MOD_7206_H

//=============================================================================
//
//      mod_7206.h
//
//      List modules available on CPU
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   ysato
// Contributors:ysato
// Date:        2004-12-20
// Purpose:     Define modules (and versions) available on this CPU.
// Usage:       Included from <cyg/hal/sh_regs.h>
//
//              
//####DESCRIPTIONEND####
//
//=============================================================================

//-----------------------------------------------------------------------------
// Modules provided by the CPU

#define CYGARC_SH_MOD_BSC  3
#define CYGARC_SH_MOD_BCN  2
#define CYGARC_SH_MOD_CAC  3
#define CYGARC_SH_MOD_CPG  2
#define CYGARC_SH_MOD_INTC 3
#define CYGARC_SH_MOD_PFC  3
#define CYGARC_SH_MOD_SCIF 2
#define CYGARC_SH_MOD_WDT  3
#define CYGARC_SH_MOD_CMT  1
#define CYGARC_SH_MOD_ADC  1
//#define CYGARC_SH_MOD_DMAC 1 // fix me !
#define CYGARC_SH_MOD_PCM  2

//-----------------------------------------------------------------------------
// Extra details for Cache Module (CAC)

// Cache dimenions - I/D separation
#define CYGARC_SH_MOD_CAC_I_SIZE      8192  // Size of cache in bytes
#define CYGARC_SH_MOD_CAC_I_LINE_SIZE 16    // Size of a cache line
#define CYGARC_SH_MOD_CAC_I_WAYS      4     // Associativity of the cache

#define CYGARC_SH_MOD_CAC_D_SIZE      8192  // Size of cache in bytes
#define CYGARC_SH_MOD_CAC_D_LINE_SIZE 16    // Size of a cache line
#define CYGARC_SH_MOD_CAC_D_WAYS      4     // Associativity of the cache

#define CYGARC_REG_DCACHE_ADDRESS_BASE    0xf0800000
#define CYGARC_REG_DCACHE_ADDRESS_FLUSH  0x00000000
#define CYGARC_REG_DCACHE_ADDRESS_TOP    0xf0804000
#define CYGARC_REG_DCACHE_ADDRESS_STEP   0x00000010



//-----------------------------------------------------------------------------
// Extra details for interrupt handling
#undef CYGARC_SH_SOFTWARE_IP_UPDATE

#endif // CYGONCE_HAL_MOD_7206_H
