//=============================================================================
//
//      mod_regs_intc_3.h
//
//      INTC (interrupt controller) Module (type 3) register definitions
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   ysato
// Contributors:ysato
// Date:        2004-12-16
//              
//####DESCRIPTIONEND####
//
//=============================================================================

// NOTE: This'll need restructuring as other variants are added. Type 1 should
// be fewest common registers.

//--------------------------------------------------------------------------
// Interrupt registers, module type 3
#define CYGARC_REG_ICR0                   0xfffe0800
#define CYGARC_REG_ICR1                   0xfffe0802
#define CYGARC_REG_ICR2                   0xfffe0804
#define CYGARC_REG_IRQRR                  0xfffe0806
#define CYGARC_REG_PINTER                 0xfffe0808
#define CYGARC_REG_PIRR                   0xfffe080a
#define CYGARC_REG_IBCR                   0xfffe080c
#define CYGARC_REG_IBNR                   0xfffe080e

#define CYGARC_REG_IPR1                   0xfffe0818
#define CYGARC_REG_IPR2                   0xfffe081a
#define CYGARC_REG_IPR5                   0xfffe0820
#define CYGARC_REG_IPR6                   0xfffe0c00
#define CYGARC_REG_IPR7                   0xfffe0c02
#define CYGARC_REG_IPR8                   0xfffe0c04
#define CYGARC_REG_IPR9                   0xfffe0c06
#define CYGARC_REG_IPR10                  0xfffe0c08
#define CYGARC_REG_IPR11                  0xfffe0c0a
#define CYGARC_REG_IPR12                  0xfffe0c0c
#define CYGARC_REG_IPR13                  0xfffe0c0e
#define CYGARC_REG_IPR14                  0xfffe0c10

#define CYGARC_REG_ICR_NMIL               0x8000
#define CYGARC_REG_ICR_NMIE               0x0100

#define CYGARC_REG_IPR1_IRQ0_MASK         0xf000
#define CYGARC_REG_IPR1_IRQ0_PRI1         0x1000
#define CYGARC_REG_IPR1_IRQ1_MASK         0x0f00
#define CYGARC_REG_IPR1_IRQ1_PRI1         0x0100
#define CYGARC_REG_IPR1_IRQ2_MASK         0x00f0
#define CYGARC_REG_IPR1_IRQ2_PRI1         0x0010
#define CYGARC_REG_IPR1_IRQ3_MASK         0x000f
#define CYGARC_REG_IPR1_IRQ3_PRI1         0x0001

#define CYGARC_REG_IPR2_IRQ4_MASK         0xf000
#define CYGARC_REG_IPR2_IRQ4_PRI1         0x1000
#define CYGARC_REG_IPR2_IRQ5_MASK         0x0f00
#define CYGARC_REG_IPR2_IRQ5_PRI1         0x0100
#define CYGARC_REG_IPR2_IRQ6_MASK         0x00f0
#define CYGARC_REG_IPR2_IRQ6_PRI1         0x0010
#define CYGARC_REG_IPR2_IRQ7_MASK         0x000f
#define CYGARC_REG_IPR2_IRQ7_PRI1         0x0001

#define CYGARC_REG_IPR5_PINT_MASK         0xf000
#define CYGARC_REG_IPR5_PINT_PRI1         0x1000
#define CYGARC_REG_IPR5_ADI0_MASK         0x00f0
#define CYGARC_REG_IPR5_ADI0_PRI1         0x0010
#define CYGARC_REG_IPR5_ADI1_MASK         0x000f
#define CYGARC_REG_IPR5_ADI1_PRI1         0x0001

#define CYGARC_REG_IPR6_DMAC0_MASK        0xf000
#define CYGARC_REG_IPR6_DMAC0_PRI1        0x1000
#define CYGARC_REG_IPR6_DMAC1_MASK        0x0f00
#define CYGARC_REG_IPR6_DMAC1_PRI1        0x0100
#define CYGARC_REG_IPR6_DMAC2_MASK        0x00f0
#define CYGARC_REG_IPR6_DMAC2_PRI1        0x0010
#define CYGARC_REG_IPR6_DMAC3_MASK        0x000f
#define CYGARC_REG_IPR6_DMAC3_PRI1        0x0001

#define CYGARC_REG_IPR7_DMAC4_MASK        0xf000
#define CYGARC_REG_IPR7_DMAC4_PRI1        0x1000
#define CYGARC_REG_IPR7_DMAC5_MASK        0x0f00
#define CYGARC_REG_IPR7_DMAC5_PRI1        0x0100
#define CYGARC_REG_IPR7_DMAC6_MASK        0x00f0
#define CYGARC_REG_IPR7_DMAC6_PRI1        0x0010
#define CYGARC_REG_IPR7_DMAC7_MASK        0x000f
#define CYGARC_REG_IPR7_DMAC7_PRI1        0x0001

#define CYGARC_REG_IPR8_CMT0_MASK         0xf000
#define CYGARC_REG_IPR8_CMT0_PRI1         0x1000
#define CYGARC_REG_IPR8_CMT1_MASK         0x0f00
#define CYGARC_REG_IPR8_CMT1_PRI1         0x0100
#define CYGARC_REG_IPR8_BSC_MASK          0x00f0
#define CYGARC_REG_IPR8_BSC_PRI1          0x0010
#define CYGARC_REG_IPR8_WDT_MASK          0x000f
#define CYGARC_REG_IPR8_WDT_PRI1          0x0001

#define CYGARC_REG_IPR9_MTU0A_MASK        0xf000
#define CYGARC_REG_IPR9_MTU0A_PRI1        0x1000
#define CYGARC_REG_IPR9_MTU0B_MASK        0x0f00
#define CYGARC_REG_IPR9_MTU0B_PRI1        0x0100
#define CYGARC_REG_IPR9_MTU1A_MASK        0x00f0
#define CYGARC_REG_IPR9_MTU1A_PRI1        0x0010
#define CYGARC_REG_IPR9_MTU1B_MASK        0x000f
#define CYGARC_REG_IPR9_MTU1B_PRI1        0x0001

#define CYGARC_REG_IPR10_MTU2A_MASK       0xf000
#define CYGARC_REG_IPR10_MTU2A_PRI1       0x1000
#define CYGARC_REG_IPR10_MTU2B_MASK       0x0f00
#define CYGARC_REG_IPR10_MTU2B_PRI1       0x0100
#define CYGARC_REG_IPR10_MTU3A_MASK       0x00f0
#define CYGARC_REG_IPR10_MTU3A_PRI1       0x0010
#define CYGARC_REG_IPR10_MTU3B_MASK       0x000f
#define CYGARC_REG_IPR10_MTU3B_PRI1       0x0001

#define CYGARC_REG_IPR11_MTU4A_MASK       0xf000
#define CYGARC_REG_IPR11_MTU4A_PRI1       0x1000
#define CYGARC_REG_IPR11_MTU4B_MASK       0x0f00
#define CYGARC_REG_IPR11_MTU4B_PRI1       0x0100
#define CYGARC_REG_IPR11_MTU5_MASK        0x00f0
#define CYGARC_REG_IPR11_MTU5_PRI1        0x0010
#define CYGARC_REG_IPR11_POE2_MASK        0x000f
#define CYGARC_REG_IPR11_POE2_PRI1        0x0001

#define CYGARC_REG_IPR12_MTU3SA_MASK      0xf000
#define CYGARC_REG_IPR12_MTU3SA_PRI1      0x1000
#define CYGARC_REG_IPR12_MTU3SB_MASK      0x0f00
#define CYGARC_REG_IPR12_MTU3SB_PRI1      0x0100
#define CYGARC_REG_IPR12_MTU4SA_MASK      0x00f0
#define CYGARC_REG_IPR12_MTU4SA_PRI1      0x0010
#define CYGARC_REG_IPR12_MTU4SB_MASK      0x000f
#define CYGARC_REG_IPR12_MTU4SB_PRI1      0x0001

#define CYGARC_REG_IPR13_MTU5S_MASK       0xf000
#define CYGARC_REG_IPR13_MTU5S_PRI1       0x1000
#define CYGARC_REG_IPR13_POE2_MASK        0x0f00
#define CYGARC_REG_IPR13_POE2_PRI1        0x0100
#define CYGARC_REG_IPR13_IIC3_MASK        0x00f0
#define CYGARC_REG_IPR13_IIC3_PRI1        0x0010

#define CYGARC_REG_IPR14_SCIF0_MASK       0xf000
#define CYGARC_REG_IPR14_SCIF0_PRI1       0x1000
#define CYGARC_REG_IPR14_SCIF1_MASK       0x0f00
#define CYGARC_REG_IPR14_SCIF1_PRI1       0x0100
#define CYGARC_REG_IPR14_SCIF2_MASK       0x00f0
#define CYGARC_REG_IPR14_SCIF2_PRI1       0x0010
#define CYGARC_REG_IPR14_SCIF3_MASK       0x000f
#define CYGARC_REG_IPR14_SCIF3_PRI1       0x0001
